#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "include/main.h"
#include "include/card.h"

CARD new_card(char *o, char *r) {
    CARD c;
    c.obverse = o;
    c.reverse = r;
    return c;
}

CARD* card_parse_csv(char *f, int *ct) {
    FILE *fp;
    char *l, *o, *r;
    const char *delims = "	\0";
    CARD *ca;

    if ((fp = fopen(f, "r")) == NULL)
        die("failed to open file (null pointer)");

    *ct = 0;

    while ((l = fgetl(fp)) != NULL) {

        if ((o = strtok(l, delims)) == NULL)
            die("improper csv format");
        if ((r = strtok(NULL, delims)) == NULL)
            die("improper csv format");

        /* printf("o: `%s`, r: `%s`\n", o, r); */

        ca = (CARD *)realloc((void *)ca, (sizeof(CARD) * ++(*ct)));
        ca[(*ct) - 1] = new_card(strdup_(o), strdup_(r));

        free(l);
        l = NULL;
    }

    return ca;
}
